## plash-1.11.tar.gz

=== glibc-extra/plash/Makefile ===
# Copyright (C) 2004, 2005 Mark Seaborn
#
# This file is part of Plash, the Principle of Least Authority Shell.
#
# Plash is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Plash is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Plash; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA.


subdir := plash

all: # Make this the default target; it will be defined in Rules. 

routines := not-cancel not-cancel-open

include ../Rules

=== debian/changelog ===
plash (1.11) unstable; urgency=low

  * Add run-emacs.c and plash-gnuserv.el:  major new feature.
  * Converted man pages and other documentation to DocBook format.
    Created new surface syntax for XML.
  * shell.c:  Fixed bugs in non-interactive mode (which is used when
    plash is invoked with the "-c" option) so that it works.
  * Add socket-connect.c
  * Add socket-publish.c.  Changed cap-protocol.[ch] to add a new
    interface for listening on connections, which allows you to call
    select() in your own code so that you can wait for events on
    other file descriptors.
  * fs-operations.c:  Disable the warning about open()ing directories.
    Now that fchdir() works it's less relevant.  It generates too many
    warnings with XEmacs and it gets annoying.
  * build-fs.c:  Changed the `create' argument of fs_resolve_populate()
    into a `flags' argument.
     * You can now control whether to attach the destination as a
       read-write-create slot, as a read-write object, or as read-only.
       The second choice was not available before:  this is useful for
       devices (eg. /dev/null) and sockets (eg. /tmp/.X11-unix/X0) when
       you want to grant write or connect access, but not unlink/create
       access.
     * Following symlinks:  When attaching a read-write-create slot,
       if the slot contains a symlink it will be followed.
       Note, however, that symlinks are dangerous and so there is now a
       flag for choosing whether to follow symlinks.  (However, the shell
       doesn't give you a choice yet -- it follows symlinks.)
  * build-fs-dynamic.c:  Changed dir_list method to include dt_ino (inode)
    and dt_type fields.  XEmacs won't display directory listings for
    filename completion without these.
  * shell.c:  Added checks for errors to calls to fs_resolve_populate().
  * shell.c:  When invoking an executable object, it will now set the
    cwd argument appropriately (previously, it was always unset).

 -- Mark Seaborn <mseaborn@onetel.com>  Sat, 13 Aug 2005 19:43:19 +0100

plash (1.10) unstable; urgency=low

  * Implemented fchdir():
     * Convert `struct dir_stack' to be a `struct filesys_obj'; ie. added a
       dummy vtable.  Add the function dir_stack_make().
     * For the case when open() returns a dummy FD, changed it so that the
       fs_op object (in the server) opens /dev/null, rather than the libc
       client requesting /dev/null.  This removes the need for the client's
       file namespace to contain /dev/null, and it removes the risk of an
       infinite loop if /dev/null should be mapped to a directory.
     * libc-misc.c:  Added fchdir().  Added a file descriptor table which
       maps file descriptor slot numbers to objects.  For directory FDs,
       these objects will be dir_stacks.  Added close(), not previously
       intercepted by Plash, which will now remove an entry from the
       table as well as closing the real kernel FD.
     * fs-operations.c:  Added fchdir() case.
  * libc-misc.c:  Moved duplicated error handling code into one function.

 -- Mark Seaborn <mseaborn@onetel.com>  Tue, 19 Jul 2005 22:46:31 +0100

plash (1.9) unstable; urgency=low

  * Use /var/lib/plash-chroot-jail rather than /usr/lib/plash-chroot-jail.
    It contains plash-uid-locks which needs to be writable.  For FHS
    compliance, this needs to go into /var.
  * fs-operations.c:  Convert main dispatch function to use a switch
    statement rather than a long series of tests.  List method IDs in
    make-marshal.pl and use macros to refer to them.
  * chroot.c, exec-object.c:  simplify by making them use get_process_caps()
    (which was introduced for plash-opts)
  * build-fs.c:
    New code: having constructed the node filesystem structure, there is a
    new way of turning it into a usable directory structure.  The old way
    was to copy it to create fabricated directories.  Now there is a new
    kind of fabricated directory which references the original node
    structure.  This has two useful properties over the old way:
     * New stuff can be added into the directory tree dynamically.
     * There are "combined" fabricated directories, which are like a union
       with a real directory.  Hence you can attach objects below other
       attached directories.  This provides functionality similar to
       mount points in Linux or Plan 9.
       (The difference is that Linux mount points are implemented in terms
       of the identity of directories -- their inode numbers -- whereas
       combined fab dirs follow the structure.  And mount points only work
       with directories and can only replace existing directories.
       Combined fab dirs can provide their own structure.)
    Split code out into build-fs-static.c (old) and build-fs-dynamic.c (new).
    Merge attach_ro_obj and attach_rw_slot fields of node.
    Fix potential leak when symlink_dest is overwritten (similar fix
    for the attach_slot field).
  * libc-getuid.c:  Add no-ops: set{,e,re,res}{u,g}id, which always return
    a success result.  This is necessary to run programs like `mkisofs' and
    `make' which do pointless UID operations.
  * comms.c:  Fixed bug in comm_resize that could lead to buffer overruns.
  * shell.c:  Add default installation endowment to namespace first, so
    that it can be overridden.

 -- Mark Seaborn <mseaborn@onetel.com>  Sat, 09 Jul 2005 19:37:09 -0400

plash (1.8) unstable; urgency=low

  * Add man pages (using Perl's POD format).
  * Swapped the precedences of "+" and "=>" arglist operators.
    "=>" now binds more tightly than "+".
  * Changed packaging and build system so that glibc can be built fully
    automatically.
  * fs-operations.c, libc-misc.c:  open() now has limited functionality
    for opening directories.  It will return a dummy FD (actually for
    /dev/null).  This means you can call close() on it; this is
    sufficient to run XEmacs.
  * Added the "Gobj" method to fs-operations.c.


=== debian/control ===
Source: plash
Section: shells
Priority: optional
Maintainer: Mark Seaborn <mseaborn@onetel.com>
# perl is for plash
# All else in Build-Depends is taken from Debian's glibc package
Build-Depends: perl, gettext (>= 0.10.37-1), make (>= 3.80-1), dpkg-dev (>= 1.4.1.5), debianutils (>= 1.13.1), tar (>= 1.13.11), bzip2, texinfo (>= 4.0), linux-kernel-headers (>= 2.5.999-test7-bk-9) [!hurd-i386], mig (>= 1.3-2) [hurd-i386], hurd-dev (>= 20020608-1) [hurd-i386], gnumach-dev [hurd-i386], texi2html, file, gcc-3.3 [!ia64] | gcc-3.4 [!ia64], gcc-3.3 (>= 1:3.3.5-5) [ia64] | gcc-3.4 (>= 3.4.3-2) [ia64], autoconf, binutils (>= 2.14.90.0.7-5), sed (>= 4.0.5-4), gawk, debhelper (>= 4.1.76)

Package: plash
Architecture: any
Depends: ${shlibs:Depends}
Description: The Principle of Least Authority shell (Plash)
 Plash (the Principle of Least Authority shell) is a replacement Unix
 shell which lets the user run Linux programs with access only to the
 files and directories that they need to run.
 .
 It works by virtualizing the filesystem.  Each process can have its
 own file namespace.
 .
 This implemented in two steps: Firstly, processes are run in a
 chroot() environment under different UIDs, so they can't access files
 using the normal Linux system calls and are isolated from each other.
 Secondly, in order to open files, a process makes requests to a server
 process via a socket; the server can send file descriptors across the
 socket in reply.
 .
 Plash dynamically links programs with a modified version of GNU libc
 so that they can do filesystem operations using this different
 mechanism.
 .
 No kernel modifications are required.  Plash can run Linux binaries
 unmodified, provided they are dynamically linked with libc, which is
 almost always the case.
 .
 In most cases this does not affect performance because the most
 frequently called system calls, such as read() and write(), are not
 affected.

=== debian/rules ===
#!/usr/bin/make -f

# Copyright (C) 2004 Mark Seaborn
#
# This file is part of Plash, the Principle of Least Authority Shell.
#
# Plash is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Plash is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Plash; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA.


package=plash

binary-arch:	checkroot
	$(checkdir)
	./make-glibc.sh
	./make-dirs.sh
	CC=gcc-3.3 ./make.sh libc
	CC=gcc-3.3 ./make.sh shell
	./docs/make-docs.sh
	(cd setuid && CC=gcc-3.3 ./make-setuid.sh)
	./debian/make-package.sh

define checkdir
        test -f debian/rules
endef

binary:	binary-arch

checkroot:
	$(checkdir)
	test $$(id -u) = 0
